<?php
// File: $Id: class.SF_GUI_RESSOURCES_FileManager.php,v 1.1.4.6.2.3 2007/04/24 15:58:32 bjoern Exp $
// +----------------------------------------------------------------------+
// | Version: Sefrengo $Name:  $
// +----------------------------------------------------------------------+
// | Copyright (c) 2005 - 2007 sefrengo.org <info@sefrengo.org>           |
// +----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify |
// | it under the terms of the GNU General Public License                 |
// |                                                                      |
// | This program is subject to the GPL license, that is bundled with     |
// | this package in the file LICENSE.TXT.                                |
// | If you did not receive a copy of the GNU General Public License      |
// | along with this program write to the Free Software Foundation, Inc., |
// | 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA               |
// |                                                                      |
// | This program is distributed in the hope that it will be useful,      |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
// | GNU General Public License for more details.                         |
// |                                                                      |
// +----------------------------------------------------------------------+
// + Autor: $Author: bjoern $
// +----------------------------------------------------------------------+
// + Revision: $Revision: 1.1.4.6.2.3 $
// +----------------------------------------------------------------------+
// + Description:
// +----------------------------------------------------------------------+
// + Changes:
// +----------------------------------------------------------------------+
// + ToDo:
// +----------------------------------------------------------------------+


//global $_api_path;
$GLOBALS['sf_factory']->requireClass('GUI/RESSOURCES', 'Abstract');
//require_once ($_api_path.'GUI/RESSOURCES/class.SF_GUI_RESSOURCES_Abstract.php');


class SF_GUI_RESSOURCES_FileManager extends SF_GUI_RESSOURCES_Abstract{
	
	var $custom_config = array();
	
	function SF_GUI_RESSOURCES_FileManager() {
		global $cms_lang;
		$this->lang =& $cms_lang;
		$this->custom_config['folder_ids'] = '';
		$this->custom_config['filetypes'] = '';
		$this->custom_config['subfolders'] = true;
	}
			
	function getRessourceName() {
		return 'files';
	}
	
	function getRessourceChooserImage() {
		return 'icons/rb_rsc_files.gif';
	}
	
	function getRessourceChooserDisplayedName() {
		return $this->lang['rb_res_file'];	
	}
	
	function getStartPosition() {
		return 0;
	}

	function generatePathwayReleatedData($current_position) {
		global $db, $perm, $cms_db, $client, $cfg_client, $cfg_cms;
					
		//MAKE PATHWAY
		$pos = $current_position;
		$arr_pway = array();
		$control = 0;
		 while($pos > 0 && ++$control < 50) {
			$sql = "SELECT *
			FROM ".$cms_db['directory']." C
			WHERE C.iddirectory = '".$pos."'
			LIMIT 1";
			$db->query($sql);
			$db->next_record();
			$item['name'] = $db->f('name');
			$item['position'] = $db->f('iddirectory');
			$pos = $db->f('parentid');
			array_push($arr_pway, $item);
			
		}
		
		$arr_rev = array_reverse($arr_pway);
		$level=0;
		$this->_addPathway($this->getRessourceChooserDisplayedName(), 0, $level);
		foreach($arr_rev AS $v) {
			//name, position, level
			$this->_addPathway($v['name'], $v['position'], ++$level);
		}
		
		if (count($arr_rev) > 0) {
			$this->_setPathwayOneUpIsActive(true);
			$this->_setPathwayOneUpPosition( $arr_rev[ (count($arr_rev) -2) ]['position'] );
		} else {
			$this->_setPathwayOneUpIsActive(false);
			$this->_setPathwayOneUpPosition(0);
		}
		
		$this->_setDetailswitchIsActive(true);
	}
	
	function generateCatData($current_position) {
			global $db, $perm, $cms_db, $client, $cfg_client, $cfg_cms;
			
			//print_r($this->custom_config);
			
			//make folders filter
			if ( is_array($this->custom_config['folder_ids']) ) {
				if ( count($this->custom_config['folder_ids']) >0) {
					$sql_folders = ' AND C.iddirectory IN('."'". implode("','", $this->custom_config['folder_ids']) ."') ";
				}
			} else {
				$sql_folders = '';
			}
			
			//with subcats
			if($this->custom_config['subfolders'] && is_array($this->custom_config['folder_ids']) ) {
				if ( count($this->custom_config['folder_ids']) >0) {
					$sql = "SELECT DISTINCT
						iddirectory, dirname
					FROM
						".$cms_db['directory']." C
					WHERE
						idclient= '$client' $sql_folders";
					$db->query($sql);
					$subfolder_list = array();
					while ($db->next_record()) {
						if(! $perm->have_perm( 1, 'folder', $db->f('iddirectory') ) ){
							continue;
						}
						array_push($subfolder_list, "C.dirname like '". $db->f('dirname') ."%'");	
					}
					
					$sql_subfolders = ' AND ('.implode(' OR ', $subfolder_list) .' ) ';
				} else {
					$sql_subfolders = '';
				}
			} else {
				$sql_subfolders = '';
			}
			
			$sql_folderfilter = ($sql_subfolders == '') ? $sql_folders : $sql_subfolders;
			
			//MAKE CATS
			$sql = "SELECT C.*, D.name AS firstname, D.surname, D.username
				FROM ".$cms_db['directory']." C, ".$cms_db['users']." D
				WHERE C.idclient= '$client'
					AND C.author = D.user_id
					AND C.dirname NOT LIKE('cms/%')
					$sql_folderfilter
					AND C.parentid = '".$current_position."'
				ORDER BY C.dirname";
			$db->query($sql);
		
			while( $db->next_record() ){
				if(! $perm->have_perm( 1, 'folder', $db->f('iddirectory') ) ){
					continue;
				}
				$author = $db->f('username') .
							($db->f('firstname') != '' || $db->f('surname') != '' 
								? ' ('.$db->f('firstname'). ' ' . $db->f('surname').')': '');
				//name, value, tpl_extra_parms, position, image, is_chooseable, is_editable_in_picker
				$this->_addCat($db->f('name'), $db->f('dirname'), 
									array('description' => $db->f('description'),
											'detail_description1' => '<strong>'.$this->lang['rb_description'].': </strong>'.$db->f('description').'<br />',
											'detail_description2' => '<strong>'.$this->lang['rb_author'].': </strong>'.$author.'<br />',
											'detail_description3' => '',
											'detail_description4' => '',
											'detail_description5' => '' ), 
									$db->f('iddirectory'), 'image', false, false);
			}
	}
	
	function generateItemData($current_position) {
		$this->_generateItems('items', $current_position);
	}
	
	function generateItemVariousFormatsData($current_position, $item_position) {
		$this->_generateItems('format', $current_position, $item_position);
	}
	
	/*
	 *  CUSTOM METHODS STARTS HERE
	 */
	 
	function _generateItems($type, $current_position, $item_position =null) {
		global $db, $perm, $cms_db, $client, $cfg_client, $cfg_cms;
		//echo "$type, $current_position, $item_position <br>";
		//make filetype filter
		if ( is_array($this->custom_config['filetypes']) ) {
			if ( count($this->custom_config['filetypes']) >0) {
				$sql_filetypes = ' AND B.filetype IN('."'". implode("','", $this->custom_config['filetypes']) ."') ";
			}
		} else {
			$sql_filetypes = '';
		}
		
		//get only versions
		if ($type == 'format') {
			$sql_format = ' AND A.idupl ='.$item_position;
		} else {
			$sql_format = '';
		}
		
		//MAKE ITEMS
		$thumb_types = array('gif', 'jpg','jpeg','png');
		$thumb_stencil = '<img src="%s" width="%s" height="%s" style="float:left;padding:0px 3px 3px 0px" alt="" />';
		$date_format = $cfg_cms['FormatDate'] . ' ' . $cfg_cms['FormatTime'];
		$sql = "SELECT
				A.*, A.created AS fcreated, A.lastmodified AS flastmodified, B.filetype, C.dirname, C.iddirectory, D.*
			FROM
				".$cms_db['upl']." A
				LEFT JOIN ".$cms_db['filetype']." B USING(idfiletype)
				LEFT JOIN ".$cms_db['directory']." C ON A.iddirectory=C.iddirectory,
				".$cms_db['users']." D
			WHERE
				A.idclient= '$client'
				AND A.author = D.user_id
				AND C.dirname NOT LIKE('cms/%')
				$sql_filetypes
				$sql_format
				AND C.iddirectory = '".$current_position."'
			ORDER BY
				A.filename, A.titel";

		$db -> query($sql);
	
		while ( $db->next_record() )
		{
			//item has more then one choseable format - standard: flase
			$item_position = false;
			if (! $perm->have_perm( 17, 'file', $db->f('idupl'), $db->f('iddirectory') ) ) {
				continue;
			}
			
			$pic_filename = $db->f('filename');
			$pic_filetype = $db->f('filetype');
			$name_length = strlen($pic_filename);
			$extension_length = strlen($db->f('filetype'));
			$t_name = substr ($pic_filename, 0, ($name_length - $extension_length - 1) );
			$t_name .= $cfg_client['thumbext'].'.'. $pic_filetype;
			
			//create thumbnaill if possible
			if (in_array($pic_filetype, $thumb_types)) {
				
				if (! file_exists($cfg_client['upl_path'].$db->f('dirname').$t_name) ) {
					//echo $cfg_client['upl_path'].$db->f('dirname').$t_name.'<br>';
					if ($db->f('pictwidth') >0 && $db->f('pictheight')>0 ) { 
						$im_gif_size = $this->_calculateThumbSize($db->f('pictwidth'), $db->f('pictheight'), 
											$cfg_client['thumb_size'], $cfg_client['thumb_size']);
						$thumb = sprintf($thumb_stencil,  $cfg_client['upl_htmlpath'].$db->f('dirname').$db->f('filename'), 
											$im_gif_size['width'], $im_gif_size['height'] );
					} else {
						$thumb = '';	
					}
				} else {
					// item has more then one format
					$item_position = $db->f('idupl');
					// make thumb
					$thumb = sprintf($thumb_stencil,  $cfg_client['upl_htmlpath'].$db->f('dirname').$t_name, 
										$db->f('pictthumbwidth'), $db->f('pictthumbheight'));
				} 
				
			} else {
				$thumb = '';
			}
			
			$author = $db->f('username') .
						($db->f('name') != '' || $db->f('surname') != '' 
							? ' ('.$db->f('name'). ' ' . $db->f('surname').')': '');
		
			// pictwidth   	  pictheight
			$picsize = ($db->f('pictwidth') > 0) ? $db->f('pictwidth') .'x'.$db->f('pictheight') .' px': '';
			$filesize = ( $db->f('filesize') > 1024) ? sprintf( "%01.2f", $db->f('filesize')/1024) . '&nbsp;kByte': $db->f('filesize') . '&nbsp;Byte';
			$picthumbsize = $db->f('pictthumbwidth') .'x'.$db->f('pictthumbheight') .' px';
			$fileinfo = empty($picsize) ? $filesize: $filesize .' / '. $picsize;
			
			//name, value, tpl_extra_parms, image, is_chooseable, is_editable_in_picker
			if($type == 'format') {
				$picker_val = ($this->custom_config['return_value_mode'] == 'sefrengolink') 
								? 'cms://idfile='. $db->f('idupl'):
								$cfg_client['upl_htmlpath'].$db->f('dirname').$db->f('filename');
				$this->_addVariousFormatItem($db->f('filename'), $picker_val, 
								array('description' => $this->lang['rb_res_file_picformat'] .': '.$picsize,
										'detail_description1' => $thumb,
										'detail_description2' => '<strong>'.$this->lang['rb_res_file_filewidth'].': </strong>'.$db->f('pictwidth').' px<br />',
										'detail_description3' => '<strong>'.$this->lang['rb_res_file_fileheight'].': </strong>'.$db->f('pictheight').' px<br />',
										'detail_description4' => '',
										'detail_description5' => ''
										), 
								$db->f('filetype'), true, false, $db->f('dirname'));				
				
				$picker_val = ($this->custom_config['return_value_mode'] == 'sefrengolink') 
								? 'cms://idfilethumb='. $db->f('idupl'):
								$cfg_client['upl_htmlpath'].$db->f('dirname').$t_name;
				$this->_addVariousFormatItem($t_name, $picker_val, 
								array('description' => $this->lang['rb_res_file_picformat'] .': '.$picthumbsize,
										'detail_description1' => $thumb,
										'detail_description2' => '<strong>'.$this->lang['rb_res_file_filewidth'].': </strong>'.$db->f('pictthumbwidth').' px<br />',
										'detail_description3' => '<strong>'.$this->lang['rb_res_file_fileheight'].': </strong>'.$db->f('pictthumbheight').' px<br />',
										'detail_description4' => '',
										'detail_description5' => ''
										), 
								$db->f('filetype'), true, false, $db->f('dirname'));
												
			} else {
				if ($item_position) {
					$title_after = '<span style="font-size:9px;color:#5A7BAD;" title="'.$this->lang['rb_res_file_mutiple_picsizes'].'"> (2)</span>';
				} else {
					$title_after = '';
				}
				$picker_val = ($this->custom_config['return_value_mode'] == 'sefrengolink') 
								? 'cms://idfile='. $db->f('idupl'):
								$cfg_client['upl_htmlpath'].$db->f('dirname').$db->f('filename');
				$this->_addItem($db->f('filename'), $picker_val, 
									array( 'title_after' => $title_after,
											'description' => $db->f('titel'),
											'detail_description1' => $thumb,
											'detail_description2' => '<strong>'.$this->lang['rb_title'].': </strong>'.$db->f('titel').'<br />',
											'detail_description3' => '<strong>'.$this->lang['rb_description'].': </strong>'.$db->f('description').'<br />',
											'detail_description4' => '<strong>'.$this->lang['rb_res_file_infos'].': </strong>'.$fileinfo.'<br />',
											'detail_description5' => '<strong>'.$this->lang['rb_author'].': </strong>'.$author.'<br />'
											), 
									$db->f('filetype'), true, false, $item_position, $db->f('dirname'));
			}
			
		}
	}
	
	function setFolderIds($ids) {
		if (! is_array($ids)) {
			return false;	
		}
		$this->custom_config['folder_ids'] = $ids;
	}
	
	function setFiletypes($filetypes) {
		if (! is_array($filetypes)) {
			return false;	
		}
		$this->custom_config['filetypes'] = $filetypes;
	}
	
	function setWithSubfoders($bool) {
		$this->custom_config['subfolders'] = $bool;
	}
	
	// [nothing is set] - relative url 
	// sefrengolink - returns values as cms://(idfile|idfilethumb)=\d
	function setReturnValueMode($str) {
		$this->custom_config['return_value_mode'] = $str;
	}

	function _calculateThumbSize($original_width, $original_height, 
						$new_width = '', $new_height = '', $aspectratio = true) {
		
		if( empty($new_width) && empty($new_height)) return false;
		if( empty($original_width) ||  empty($original_height) ) return false;
		
		if ($original_width < $new_width && $original_height < $new_height) {
			$out['width'] = $original_width;
			$out['height'] = $original_height;
		}
		//calculate without aspectratio
		else if($aspectratio != 'true'){
			$out['width'] = ( empty($new_width) ) ? $original_width: $new_width;
			$out['height'] = ( empty($new_height) ) ? $original_height: $new_height;
		}
		//calculate with aspectratio
		else{
			$calculate_height_by_width = round( ($new_width / $original_width) * $original_height, 0);
			$calculate_width_by_height = round( ($new_height / $original_height) * $original_width, 0);
			//both values, new height and width are set. We must figure out if we resize by
			//height or by width
			if(! empty($new_width) && ! empty($new_height)){
				//resize by height
				if($calculate_height_by_width > $new_height){
					$out['width'] = $calculate_width_by_height;
					$out['height'] = $new_height;
				}
				//resize by width
				else{
					$out['width'] = $new_width;
					$out['height'] = $calculate_height_by_width;
				}
			}
			//by width
			else if( empty($new_height) ){
				$out['width'] = $new_width;
				$out['height'] = $calculate_height_by_width;
			}
			//by height
			else if( empty($new_width) ){
				$out['width'] = $calculate_width_by_height;
				$out['height'] = $new_height;
			}
			//how did you create this nonsens?
			else{
				return false;
			}
		}

		return $out;
	}

}


?>